%% ============================================================
%%   Nom de la base   :  GESTSOC                               
%%   Nom de SGBD      :  Sybase SQL Anywhere                   
%%   Date de cration :  15/12/1997  15:44                     
%% ============================================================

if exists(select 1 from sys.systable where table_name='COMPOSE' and table_type='BASE') then
   drop table COMPOSE
end if;

if exists(select 1 from sys.systable where table_name='UTILISE' and table_type='BASE') then
   drop table UTILISE
end if;

if exists(select 1 from sys.systable where table_name='PARTICIPE' and table_type='BASE') then
   drop table PARTICIPE
end if;

if exists(select 1 from sys.systable where table_name='REGROUPE' and table_type='BASE') then
   drop table REGROUPE
end if;

if exists(select 1 from sys.systable where table_name='TACHE' and table_type='BASE') then
   drop table TACHE
end if;

if exists(select 1 from sys.systable where table_name='PROJET' and table_type='BASE') then
   drop table PROJ.PROJET
end if;

if exists(select 1 from sys.systable where table_name='SALARIE' and table_type='BASE') then
   drop table SALARIE
end if;

if exists(select 1 from sys.systable where table_name='CLIENT' and table_type='BASE') then
   drop table PROJ.CLIENT
end if;

if exists(select 1 from sys.systable where table_name='MATERIEL' and table_type='BASE') then
   drop table MATERIEL
end if;

if exists(select 1 from sys.systable where table_name='DIVISION' and table_type='BASE') then
   drop table ADMN.DIVISION
end if;

if exists(select 1 from sys.systable where table_name='EQUIPE' and table_type='BASE') then
   drop table EQUIPE
end if;

if exists(select 1 from systypes where name='T_ID') then
   drop datatype T_ID
end if;

create datatype T_ID numeric(4)  
        check (
            @column between 1 and 9999);

if exists(select 1 from systypes where name='T_MONNAIE') then
   drop datatype T_MONNAIE
end if;

create datatype T_MONNAIE numeric(8,2)  
        check (
            @column >= 0);

if exists(select 1 from systypes where name='T_NOM') then
   drop datatype T_NOM
end if;

create datatype T_NOM char(40)  ;

if exists(select 1 from systypes where name='T_TELEPHONE') then
   drop datatype T_TELEPHONE
end if;

create datatype T_TELEPHONE char(12)  ;

if exists(select 1 from systypes where name='T_TEXTE_COURT') then
   drop datatype T_TEXTE_COURT
end if;

create datatype T_TEXTE_COURT char(80)  ;

%% ============================================================
%%   Table : EQUIPE                                            
%% ============================================================
create table EQUIPE
(
    EQUNUM      T_ID                  not null,
    EQUNBR      numeric(4)                    
        check (
            EQUNBR is null or (EQUNBR >= 1
            )),
    EQUSPE      T_TEXTE_COURT                 ,
    primary key (EQUNUM)
);

comment on table EQUIPE is 'Description d''une quipe';

comment on column EQUIPE.EQUNUM is 'numro d''quipe';

comment on column EQUIPE.EQUNBR is 'nombre d''employs';

comment on column EQUIPE.EQUSPE is 'spcialisation de l''quipe';


%% ============================================================
%%   Table : DIVISION                                          
%% ============================================================
create table ADMN.DIVISION
(
    DIVNUM      T_ID                  not null,
    DIVNOM      T_NOM                         ,
    DIVCA       T_MONNAIE                     ,
    DIVADR      T_TEXTE_COURT                 ,
    primary key (DIVNUM)
);

comment on table ADMN.DIVISION is 'Description d''une division';

comment on column ADMN.DIVISION.DIVNUM is 'numro de la division';

comment on column ADMN.DIVISION.DIVNOM is 'nom de la division';

comment on column ADMN.DIVISION.DIVCA is 'chiffre d''affaires';

comment on column ADMN.DIVISION.DIVADR is 'adresse de la division';


%% ============================================================
%%   Table : MATERIEL                                          
%% ============================================================
create table MATERIEL
(
    MATNUM      T_ID                  not null,
    MATNOM      T_NOM                 not null,
    MATTYP      T_NOM                         ,
    primary key (MATNUM)
);

comment on table MATERIEL is 'Description d''un matriel';

comment on column MATERIEL.MATNUM is 'numro du matriel';

comment on column MATERIEL.MATNOM is 'nom du matriel';

comment on column MATERIEL.MATTYP is 'type matriel';


%% ============================================================
%%   Table : CLIENT                                            
%% ============================================================
create table PROJ.CLIENT
(
    CLINUM      T_ID                  not null,
    CLINOM      T_NOM                         ,
    CLIRAI      T_TEXTE_COURT                 ,
    CLIADR      T_TEXTE_COURT                 ,
    CLIACT      T_TEXTE_COURT                 ,
    CLICON      T_NOM                         ,
    CLITEL      T_TELEPHONE                   ,
    CLIFAX      T_TELEPHONE                   ,
    primary key (CLINUM)
);

comment on table PROJ.CLIENT is 'Description d''un client';

comment on column PROJ.CLIENT.CLINUM is 'numro du client';

comment on column PROJ.CLIENT.CLINOM is 'nom du client';

comment on column PROJ.CLIENT.CLIRAI is 'raison sociale du client';

comment on column PROJ.CLIENT.CLIADR is 'adresse du client';

comment on column PROJ.CLIENT.CLIACT is 'activit du client';

comment on column PROJ.CLIENT.CLICON is 'contact chez le client';

comment on column PROJ.CLIENT.CLITEL is 'numro de tlphone du client';

comment on column PROJ.CLIENT.CLIFAX is 'numro de fax du client';


%% ============================================================
%%   Table : SALARIE                                           
%% ============================================================
create table SALARIE
(
    SALNUM      T_ID                  not null,
    DIVNUM      T_ID                  not null,
    SALRESP     T_ID                          ,
    SALNOM      T_NOM                         ,
    SALPRE      T_NOM                         ,
    SALFON      T_NOM                         ,
    SALREM      T_MONNAIE                     ,
    SALCOM      T_MONNAIE                     ,
    primary key (SALNUM)
);

comment on table SALARIE is 'Description d''un salari';

comment on column SALARIE.SALNUM is 'numro du salari';

comment on column SALARIE.DIVNUM is 'numro de la division';

comment on column SALARIE.SALRESP is 'numro du salari';

comment on column SALARIE.SALNOM is 'nom du salari';

comment on column SALARIE.SALPRE is 'prnom du salari';

comment on column SALARIE.SALFON is 'fonction du salari';

comment on column SALARIE.SALREM is 'rmunration du salari';

comment on column SALARIE.SALCOM is 'commission du salari';


%% ============================================================
%%   Table : PROJET                                            
%% ============================================================
create table PROJ.PROJET
(
    PRONUM      T_ID                  not null,
    SALNUM      T_ID                  not null,
    CLINUM      T_ID                  not null,
    ACTDEB      date                          ,
    ACTFIN      date                          ,
    PROTHE      T_NOM                         ,
    PROLIB      T_TEXTE_COURT                 ,
    primary key (PRONUM)
);

comment on table PROJ.PROJET is 'Description d''un projet';

comment on column PROJ.PROJET.PRONUM is 'numro du projet';

comment on column PROJ.PROJET.SALNUM is 'numro du salari';

comment on column PROJ.PROJET.CLINUM is 'numro du client';

comment on column PROJ.PROJET.ACTDEB is 'date de dbut du projet';

comment on column PROJ.PROJET.ACTFIN is 'date de fin du projet';

comment on column PROJ.PROJET.PROTHE is 'thme du projet';

comment on column PROJ.PROJET.PROLIB is 'libell du projet';


%% ============================================================
%%   Table : TACHE                                             
%% ============================================================
create table TACHE
(
    PRONUM      T_ID                  not null,
    TACNOM      T_NOM                 not null,
    ACTDEB      date                          ,
    ACTFIN      date                          ,
    TACCOU      T_MONNAIE                     ,
    primary key (PRONUM, TACNOM)
);

comment on table TACHE is 'Description d''une tche';

comment on column TACHE.PRONUM is 'numro du projet';

comment on column TACHE.TACNOM is 'nom de la tche';

comment on column TACHE.ACTDEB is 'date de dbut du projet';

comment on column TACHE.ACTFIN is 'date de fin du projet';

comment on column TACHE.TACCOU is 'cot en mois-homme de la tche';


%% ============================================================
%%   Table : REGROUPE                                          
%% ============================================================
create table REGROUPE
(
    EQUNUM      T_ID                  not null,
    SALNUM      T_ID                  not null,
    primary key (EQUNUM, SALNUM)
);

comment on table REGROUPE is 'une quipe REGROUPE des salaris';

comment on column REGROUPE.EQUNUM is 'numro d''quipe';

comment on column REGROUPE.SALNUM is 'numro du salari';


%% ============================================================
%%   Table : PARTICIPE                                         
%% ============================================================
create table PARTICIPE
(
    PRONUM      T_ID                  not null,
    TACNOM      T_NOM                 not null,
    SALNUM      T_ID                  not null,
    PARDEB      date                          ,
    PARFIN      date                          ,
    primary key (PRONUM, TACNOM, SALNUM)
);

comment on table PARTICIPE is 'un salari PARTICIPE  une tche';

comment on column PARTICIPE.PRONUM is 'numro du projet';

comment on column PARTICIPE.TACNOM is 'nom de la tche';

comment on column PARTICIPE.SALNUM is 'numro du salari';

comment on column PARTICIPE.PARDEB is 'date de dbut de participation';

comment on column PARTICIPE.PARFIN is 'date de fin de participation';


%% ============================================================
%%   Table : UTILISE                                           
%% ============================================================
create table UTILISE
(
    SALNUM      T_ID                  not null,
    MATNUM      T_ID                  not null,
    primary key (SALNUM, MATNUM)
);

comment on table UTILISE is 'un salari UTILISE du matriel';

comment on column UTILISE.SALNUM is 'numro du salari';

comment on column UTILISE.MATNUM is 'numro du matriel';


%% ============================================================
%%   Table : COMPOSE                                           
%% ============================================================
create table COMPOSE
(
    MATNUM      T_ID                  not null,
    MAT_MATNUM  T_ID                  not null,
    primary key (MATNUM, MAT_MATNUM)
);

comment on table COMPOSE is 'relation de composition';

comment on column COMPOSE.MATNUM is 'numro du matriel';

comment on column COMPOSE.MAT_MATNUM is 'numro du matriel';


alter table SALARIE
    add foreign key FK_SALARIE_TRAVAILLE_DIVISION (DIVNUM)
       references ADMN.DIVISION (DIVNUM) on update restrict on delete restrict;

alter table SALARIE
    add foreign key FK_SALARIE_A_POUR_CH_SALARIE (SALRESP)
       references SALARIE (SALNUM) on update restrict on delete restrict;

alter table PROJ.PROJET
    add foreign key FK_PROJET_COORDONNE_SALARIE (SALNUM)
       references SALARIE (SALNUM) on update restrict on delete restrict;

alter table PROJ.PROJET
    add foreign key FK_PROJET_COMMANDE_CLIENT (CLINUM)
       references PROJ.CLIENT (CLINUM) on update restrict on delete restrict;

alter table TACHE
    add foreign key FK_TACHE_CONSTITUE_PROJET (PRONUM)
       references PROJ.PROJET (PRONUM) on update restrict on delete restrict;

alter table REGROUPE
    add foreign key FK_REGROUPE_EST_COMPO_EQUIPE (EQUNUM)
       references EQUIPE (EQUNUM) on update restrict on delete restrict;

alter table REGROUPE
    add foreign key FK_REGROUPE_COMPOSE_SALARIE (SALNUM)
       references SALARIE (SALNUM) on update restrict on delete restrict;

alter table PARTICIPE
    add foreign key FK_PARTICIP_EST_EFFEC_TACHE (PRONUM, TACNOM)
       references TACHE (PRONUM, TACNOM) on update restrict on delete restrict;

alter table PARTICIPE
    add foreign key FK_PARTICIP_EFFECTUE_SALARIE (SALNUM)
       references SALARIE (SALNUM) on update restrict on delete restrict;

alter table UTILISE
    add foreign key FK_UTILISE_UTILISE_SALARIE (SALNUM)
       references SALARIE (SALNUM) on update restrict on delete restrict;

alter table UTILISE
    add foreign key FK_UTILISE_EST_UTILI_MATERIEL (MATNUM)
       references MATERIEL (MATNUM) on update restrict on delete restrict;

alter table COMPOSE
    add foreign key FK_COMPOSE_COMPOSE_MATERIEL (MATNUM)
       references MATERIEL (MATNUM) on update restrict on delete restrict;

alter table COMPOSE
    add foreign key FK_COMPOSE_COMPOSANT_MATERIEL (MAT_MATNUM)
       references MATERIEL (MATNUM) on update restrict on delete restrict;

